[Date Prev][Date Next] [Thread Prev][Thread Next] [Date Index] [Thread Index]

Skip kbd-chooser when running under Xen



Hi,

When running the installer in a Xen paravirtualised environment,
kbd-chooser errors out after selecting a keymap:

Select a keyboard layout
------------------------

Keymap to use:
  1. American English [*]         23. Italian    
[...]
 22. Icelandic                   
Prompt: '?' for help, default=1> 

!! ERROR: Installation step failed

An installation step failed. You can try to run the failing item again from the
menu, or skip it and choose something else. The failing step is: Select a 
keyboard layout
[Press enter to continue] 

I'm not exactly sure why this happens, but the whole thing doesn't
make much sense to me, as a virtual computer doesn't rellay have a
keyboard attached.  Therefore I propose the following patch:

Index: packages/kbd-chooser/debian/kbd-chooser.isinstallable
===================================================================
--- packages/kbd-chooser/debian/kbd-chooser.isinstallable	(revision 52852)
+++ packages/kbd-chooser/debian/kbd-chooser.isinstallable	(working copy)
@@ -1,4 +1,8 @@
 #!/bin/sh
 . /usr/share/debconf/confmodule
 db_get auto-install/enable && [ "$RET" = true ] && exit 1
+
+# A paravirtualised system has no keyboard attached
+[ -d /proc/xen ] && exit 1
+
 exit 0
which makes kbd-chooser not installable in a Xen paravirtualised
environment.  At least.  Of course several questions arise:

 * What happens under a fully virtualised environment?  Does
   kbd-chooser error out?  Does it make sense?  Is /proc/xen present?

 * Using /proc for such things is deprecated, should we check
   /sys/bus/xen or /sys/devices/xen instead?

 * Should we use a more elaborate detection method, like the short C
   program presented in
   http://lists.xensource.com/archives/html/xen-changelog/2007-02/msg00075.html
   for example?

 * Should this problem be solved by other means, like Subarchitecture
   specifications, whatever those are?  See
   http://lists.debian.org/debian-boot/2003/09/msg00854.html
-- 
Regards,
Feri.

Reply to: